<?php

if(defined('MAGIC360_PARAMS_LOADED')) return;

define('MAGIC360_PARAMS_LOADED', true);

function func_get_magic360_blocks() {
	return array(
		'default' => 'Product page'
	);
}
function func_load_magic360_params() {
	global $xcart_tbl_prefix;
	$table_prefix = defined('XC_TBL_PREFIX') ? XC_TBL_PREFIX : (isset($xcart_tbl_prefix) ? $xcart_tbl_prefix : 'xcart_');
	$sql = 'INSERT INTO `'.$table_prefix.'magic360` (`block`, `name`, `value`, `enabled`) VALUES
		(\'default\', \'version\', \'5.5.0\', 1),
		(\'default\', \'enable-effect\', \'Yes\', 1),
		(\'default\', \'magnify\', \'Yes\', 1),
		(\'default\', \'magnifier-width\', \'80%\', 1),
		(\'default\', \'magnifier-shape\', \'inner\', 1),
		(\'default\', \'fullscreen\', \'Yes\', 1),
		(\'default\', \'spin\', \'drag\', 1),
		(\'default\', \'autospin-direction\', \'clockwise\', 1),
		(\'default\', \'sensitivityX\', \'50\', 1),
		(\'default\', \'sensitivityY\', \'50\', 1),
		(\'default\', \'mousewheel-step\', \'1\', 1),
		(\'default\', \'autospin-speed\', \'3600\', 1),
		(\'default\', \'smoothing\', \'Yes\', 1),
		(\'default\', \'autospin\', \'once\', 1),
		(\'default\', \'autospin-start\', \'load,hover\', 1),
		(\'default\', \'autospin-stop\', \'click\', 1),
		(\'default\', \'initialize-on\', \'load\', 1),
		(\'default\', \'start-column\', \'1\', 1),
		(\'default\', \'start-row\', \'auto\', 1),
		(\'default\', \'loop-column\', \'Yes\', 1),
		(\'default\', \'loop-row\', \'No\', 1),
		(\'default\', \'reverse-column\', \'No\', 1),
		(\'default\', \'reverse-row\', \'No\', 1),
		(\'default\', \'column-increment\', \'1\', 1),
		(\'default\', \'row-increment\', \'1\', 1),
		(\'default\', \'thumb-max-width\', \'200\', 1),
		(\'default\', \'thumb-max-height\', \'200\', 1),
		(\'default\', \'square-images\', \'disable\', 1),
		(\'default\', \'disable-for-thumbnail\', \'No\', 1),
		(\'default\', \'show-message\', \'Yes\', 1),
		(\'default\', \'message\', \'Drag image to spin\', 1),
		(\'default\', \'loading-text\', \'Loading...\', 1),
		(\'default\', \'fullscreen-loading-text\', \'Loading large spin...\', 1),
		(\'default\', \'hint\', \'Yes\', 1),
		(\'default\', \'hint-text\', \'Drag to spin\', 1),
		(\'default\', \'mobile-hint-text\', \'Swipe to spin\', 1),
		(\'default\', \'imagemagick\', \'off\', 1),
		(\'default\', \'image-quality\', \'75\', 1),
		(\'default\', \'icon\', \'images/360icon.png\', 1),
		(\'default\', \'watermark\', \'\', 1),
		(\'default\', \'watermark-max-width\', \'30%\', 1),
		(\'default\', \'watermark-max-height\', \'30%\', 1),
		(\'default\', \'watermark-opacity\', \'50\', 1),
		(\'default\', \'watermark-position\', \'center\', 1),
		(\'default\', \'watermark-offset-x\', \'0\', 1),
		(\'default\', \'watermark-offset-y\', \'0\', 1)';
	return db_query($sql);
}

function func_get_magic360_params_map() {
	return array(
		'default' => array(
			'General' => array(
				'enable-effect' => true
			),
			'Magic 360' => array(
				'magnify' => true,
				'magnifier-width' => true,
				'magnifier-shape' => true,
				'fullscreen' => true,
				'spin' => true,
				'autospin-direction' => true,
				'sensitivityX' => true,
				'sensitivityY' => true,
				'mousewheel-step' => true,
				'autospin-speed' => true,
				'smoothing' => true,
				'autospin' => true,
				'autospin-start' => true,
				'autospin-stop' => true,
				'initialize-on' => true,
				'start-column' => true,
				'start-row' => true,
				'loop-column' => true,
				'loop-row' => true,
				'reverse-column' => true,
				'reverse-row' => true,
				'column-increment' => true,
				'row-increment' => true
			),
			'Positioning and Geometry' => array(
				'thumb-max-width' => true,
				'thumb-max-height' => true,
				'square-images' => true
			),
			'Miscellaneous' => array(
				'disable-for-thumbnail' => true,
				'show-message' => true,
				'message' => true,
				'loading-text' => true,
				'fullscreen-loading-text' => true,
				'hint' => true,
				'hint-text' => true,
				'mobile-hint-text' => true,
				'imagemagick' => true,
				'image-quality' => true,
				'icon' => true
			),
			'Watermark' => array(
				'watermark' => true,
				'watermark-max-width' => true,
				'watermark-max-height' => true,
				'watermark-opacity' => true,
				'watermark-position' => true,
				'watermark-offset-x' => true,
				'watermark-offset-y' => true
			)
		)
	);
}

?>
